
    'WINDOWS-ONLY EXAMPLE

    'calldll-example02.bas - demonstrate the SetEnvironmentVariableA
    'and GetEnvironmentVariableA API functions.  Notice the use of
    'LPCSTR, LPSTR, DWORD, and BOOL which are new to LB v5.0.

    print SetEnvironmentVariable("MyVar", time$() + " Liberty BASIC")
    print GetEnvironmentVariable$("MyVar")
    end

function GetEnvironmentVariable$(varName$)
    MAXPATH = 199
    buffer$ = space$(MAXPATH) + chr$(0)
    nSize = len(buffer$)
    calldll #kernel32, "GetEnvironmentVariableA",_
        varName$ as LPCSTR,_
        buffer$  as LPSTR,_
        nSize    as DWORD,_
        result   as DWORD
    GetEnvironmentVariable$ = Left$(buffer$, result)
end function

function SetEnvironmentVariable(varName$, value$)
    calldll #kernel32, "SetEnvironmentVariableA",_
        varName$  as LPCSTR,_
        value$    as LPCSTR,_
        result    as BOOL
    SetEnvironmentVariable = result
end function
