' ----------------------------------
' LB5 lock test monster
' ----------------------------------
libPath$ = getLibPath$()
db$ = "test.db"
if libPath$ = "" then
  sqliteconnect #sql,  db$
  sqliteconnect #sql1,  db$
else
  sqliteconnect #sql,  db$, libPath$
  sqliteconnect #sql1,  db$, libPath$
end if
' ****************
' No table then create it with a unique key
'
sql$ = "SELECT * FROM sqlite_master WHERE tbl_name = 'xx'"
#sql execute(sql$)
rows = #sql ROWCOUNT()
if rows = 0 then
	sql$ = "
	CREATE TABLE xx (
	xxNum	integer(5),
	xxDescr	VARCHAR(10),
	xxCount	integer(5))"
	#sql execute(sql$)
	
	#sql execute("CREATE UNIQUE INDEX xx_num ON xx(xxNum)") ' give it a unique index
	
	print "Table A Created"
end if

' re populate the table with new stuff
#sql execute("DELETE FROM xx")
for i = 1 to 100
	#sql execute("INSERT INTO xx VALUES (";i;",'xx_";right$("000"+str$(i),3);"',0)")
next i
' ************ this causes it to lock *************
sql$ = "PRAGMA table_info(xx)" ' returns cid|name|type|notnull|dflt_value|pk
print sql$
#sql execute(sql$) ' **************** comment this and it works
' ***********************
' read the table 10 rows 10 time
' then do INSERT OR UPDATE to the last row read
'
for pass = 1 to 10
	#sql execute("SELECT * FROM xx WHERE rowid > ";pass;" ORDER BY xxNum LIMIT 1")
	rows    = #sql ROWCOUNT()       'Get the number of rows
	
	print "Number of rows in table xx:";rows
		#row 		= #sql #nextrow()
		xxNum		= #row xxNum()
		xxDescr$	= #row xxDescr$()
		xxCount		= #row xxCount()
' *******************
sql1$ = "UPDATE xx SET xxCount = xxCount + 5 WHERE xxNum = ";xxNum
#sql1 execute(sql1$)
' ***********************	
		print xxNum;chr$(9);xxDescr$;chr$(9);xxCount
	
	print "** end of select ** pass: ";pass
	' INSERT OR REPLACE the last record read
	'
	sql$ = "INSERT OR REPLACE INTO xx VALUES(";xxNum;",'";xxDescr$;"',";pass;")"
	print sql$
	#sql execute(sql$)
next pass
#sql  disconnect()
end
function getLibPath$()
    files #dir, "/usr/lib/libsq*"
    if #dir hasanswer() then
        getLibPath$ = "/usr/lib"
    else
        files #dir, "/usr/lib64/libsq*"
        if #dir hasanswer() then getLibPath$ = "/usr/lib64"
    end if
end function
