'boyFlipsForGirl - an example from the Liberty BASIC documentation, updated for LB5

  nomainwin

  WindowWidth=410
  WindowHeight=450
  UpperLeftX=50
  UpperLeftY=5
  graphicbox #w.g, 0,0,400,300
  graphicbox #w.s, 0,301,100,100
  open "Animation" for window_nf as #w
  #w "trapclose [quit]"

  'draw background:
  #w.g down() : #w.g fill("blue")
  #w.g color("red") : #w.g backcolor("red")
  #w.g boxfilled(200, 150)
  #w.g getbmp("landscape", 0, 0, 399, 299)

  'set background:
  #w.g background("landscape")
  'draw sprite and mask:
  #w.s down() : #w.s fill("white") : #w.s backcolor("black")
  #w.s color("black") : #w.s place(0, 40)
  #w.s boxfilled(80, 80)

  'masks:
  #w.s "place 20 20"
  #w.s "circlefilled 18"
  #w.s "place 60 20;circlefilled 18"

  'sprite 1:
  #w.s "color yellow;backcolor yellow"
  #w.s "place 20 60;circlefilled 18"
  #w.s "color black;backcolor black;size 4"
  #w.s "set 14 55; set 26 55; size 1"
  #w.s "place 20 67"
  #w.s "ellipsefilled 20 5"
  #w.s "Getbmp ball1 0 0 40 80"

  'add sprite, set auto-move
  #w.g addsprite("guy", "ball1")
  #w.g spritemovexy("guy", 3, 2)

  'sprite 2:
  #w.s color("pink") : #w.s backcolor("pink")
  #w.s place(60, 60) : #w.s circlefilled(18)
  #w.s color("blue") : #w.s size(4)
  #w.s set(54, 55) : #w.s set(66, 55)
  #w.s color("darkpink") : #w.s backcolor("darkpink") : #w.s size(1)
  #w.s place(60, 67)
  #w.s ellipsefilled(20, 7)
  #w.s getbmp("ball2", 40, 0, 40, 80)

  'add sprite2, set auto-move
  #w.g addsprite("girl", "ball2")
  #w.g spritexy("girl", 380, 280)
  #w.g spritemovexy("girl", -2, -2)

  'move sprites, scroll background,
  'check for collisions:
  ms = timerScroll(10)
  wait

[scroll]
  if ms = 0 then wait 'this causes any extra ticks to be ignored
  x=x-5:y=y+5
  #w.g backgroundxy(x, y)
  #w.g drawsprites()
  list$ = #w.g spritecollides$("guy")
  if list$="girl" then
    #w.g spriteorient("guy", "flip")
    #w.g drawsprites()
    #w.g color("black") : #w.g font("arial", 14)
    #w.g place(140, 280) : #w.g "|Boy flips for girl!"
    ms = timerScroll(0)
  end if
  wait

function timerScroll(ms)
  timer ms, [scroll]
  timerScroll = ms
end function

[quit]
  close #w
  end
