    'coolFractal.bas contributed by Rod
    'nomainwin
    dim col(12,2)
    WindowWidth = 640
    WindowHeight = 480
    midx=int(WindowWidth/2)
    midy=int(WindowHeight/2)
    button #1.clear, "Clear", [clear], LR, 50, 10, 65, 25
    open "Fractals" for graphics as #1
    #1 trapclose("[quit]")

    [clear]
    #1 cls()
    #1 down()
    #1 fill("black")


[draw]
    'set up some random colors
    for c=0 to 12
      col(c,0)=int(rnd(0)*256)
      col(c,1)=int(rnd(0)*256)
      col(c,2)=int(rnd(0)*256)
    next c

    'set up some random starting positions
    a=rnd(0)
    b=0.9998
    c=2-2*a
    dots=12000
    x=j=0
    y=rnd(0)*12+0.1

    'calculate and draw the points
    for i=0 to dots
        scan
        #1 size(i/4000+1)
        z=x
        x=b*y+j
        j=a*x+c*(x^2)/(1+x^2)
        y=j-z
        xp=(x*20)+midx
        yp=(y*20)+midy
        colorIndex = i/1000
        #1 color(col(colorIndex, 0), col(colorIndex, 1), col(colorIndex, 2))
        #1 set(xp, yp)
    next i
    input "press enter"; a$
    goto [draw]

[quit]
    close #1
    end
