    nomainwin

    gr=3
    prompt "Select granularity (1 [very fine] - 20 [very course])";gr
    gr=abs(int(gr))
    if gr<3 then
        confirm "This will take a LONG time.  Proceed?";ans$
        if ans$="no" then [start]
    end if

[setupWindow]
    UpperLeftX=1
    UpperLeftY=1
    WindowWidth=900
    WindowHeight=800
    open "Julia Set" for graphics as #1
    #1 "trapclose [q];fill black;flush;down;color white;size ";gr

    w = 850
    h = 750
    zoom = 1
    maxiter = 255
    moveX = 0
    moveY = 0
    cX = -0.7
    cY = 0.27015

    global zx, zy, tmp, i, rd, gn, bu
    global col$, lastCol$
    t0=time$("ms")
    w2=int(w/2)
    h2=int(h/2)

    zw=0.5*zoom*w
    zh=0.5*zoom*h

    for x = 0-w2 to 0 step gr
        scan
        for y = 0-h2 to h2 step gr
            zx=1.5*x/zw'+moveX
            zy=y/zh'+moveY
            i=maxiter
            li=maxiter
            while zx*zx+zy*zy<4 and i>1
                tmp = zx * zx - zy * zy + cX
                zy = 2.0 * zx * zy + cY
                zx = tmp
                i=i-1
            wend
            i=255-i
            if i<>li then #1 "color ";min(255,i);" ";min(i*i,255);" ";min(255,i*i*i) :li=i
            #1 "set ";x+w2;" ";y+h2
            #1 "set ";w2-x;" ";h2-y
        next y
    next x
    #1 "flush"
    t1=time$("ms")
    notice "Complete ";t1-t0
    wait

[q]
    close #1
    end
