

    ' Plot a mandala with 20 vertices
    'nomainwin
    dim verticesX(100)
    dim verticesY(100)
    verticesQty = 20
    diameter = 375
    radius = int(diameter/2)
    angle = 360/verticesQty

  WindowWidth = 520
  WindowHeight = 415
  graphicbox #mand.draw, 10, 10, 500, 400
  open "paint here" for window as #mand
  #mand "trapclose [quit]"

#mand.draw "up"
    ' Create vector table
    for i = 1 to verticesQty

        ' Place turtle in center of screen pointing to top of screen
        print #mand.draw, "home"
        print #mand.draw, "north"

        ' Turn to next vector and 'go' there
        print #mand.draw, "turn "; i * angle
        print #mand.draw, "go "; radius

        ' Ask for turtle position in xy
        print #mand.draw, "posxy vrtcX vrtcY"

        ' Add to table
        verticesX(i) = vrtcX
        verticesY(i) = vrtcY

    next i
'input a$

    ' Draw - put the pen down - draw using XOR
    print #mand.draw, "down; rule xor"

    ' Draw each individual line in the mandala
    for a = 1 to verticesQty
        for b = a to verticesQty
            print #mand.draw, "line "; verticesX(a); " "; verticesY(a); " "; verticesX(b); " "; verticesY(b)
        next b
'#mand.draw "flush"
    next a

    ' Force the drawing to 'stick'
    print #mand.draw, "flush"

    ' stop to look at the drawing
    wait

[quit]
    ' Close the window
    print "quitting"
    close #mand
    end
