'testGraphicsCommands.bas

	nomainwin
	global performRedraws
	WindowWidth = 1024
	WindowHeight = 768
	open "Test Graphics Commands" for graphics as #draw
	#draw down()

	call background #draw
	call circles #draw
	call turtle #draw
	call boxes #draw
	call images #draw
	call fonts #draw
	gosub [bitBlit]
	gosub [sprites]
	#draw flush()
	notice "Make a mess before redraw, then proceed to redraw."
	call makeMess #draw
	call pause
	#draw redraw()
	wait


sub pause
	timer 1000, [go]
	wait
  [go]
	timer 0
end sub


sub redraw #gr
'	if performRedraws then #gr redraw()
	if performRedraws then #gr "redraw"
end sub

sub background #gr

	#gr fill("gray")
	notice "Continue from gray"
	#gr cls(200, 255, 200)
	notice "Continue from mint green red 200, green 255, blue 200"
	#gr size(10)
	for y = 10 to 400 step 10
		color = 260 - y/1.5
		#gr color(color, color, color)
		#gr place(10, y)
		#gr line(10, y, 610, y)
	next y
	#gr size(1)
end sub


sub circles #gr

	for x = 1 to 5
		#gr color(word$("red green blue orange gray", x))
		#gr place(x * 10 + 25, 55)
		#gr circle(20+x*3)
		#gr flush()
	next x

end sub


sub turtle #gr

	#gr place(220, 100)
	for x = 1 to 50
		#gr size(x/7+1)
		#gr color(word$("red green blue yellow cyan", 1 + x mod 5))
	    #gr go(x*3)
		#gr turn(94)
	next x

end sub

sub boxes #gr

	#gr place(400, 100)
	for x = -80 to 80 step 20
		boxColor$ = word$("yellow cyan red green blue", 1 + abs(x/20) mod 5)
		if x > 0 then
			#gr size(abs(x) / 12 + 1)
			#gr color(boxColor$)
			#gr box(400+x, 100+x)
		  else
			#gr size(1)
			#gr color(boxColor$)
			#gr backcolor(boxColor$)
			#gr boxfilled(400+x, 100+x)
		end if
	next x

end sub

sub images #gr

	#gr font("arial", 10)
	loadimage "globe", "bmp\globe.jpg"
	#gr drawimage("globe", 500, 20)
	#gr place(500, 18)
	#gr color("blue")
	#gr "|JPG"
	loadimage "title", "bmp\TITLETTT.BMP"
	#gr drawimage("title", 500, 100)
	#gr place(500, 98)
	#gr color("red")
	#gr "|BMP"
	loadimage "icon", "bmp\lbiconshot.png"
	#gr drawimage("icon", 500, 150)
	#gr place(500, 148)
	#gr color("yellow")
	#gr "|PNG"
	#gr "getbmp grab 510 30 50 180"
	#gr drawimage("grab", 630, 30)

end sub

sub makeMess #drawMessHere

	for x = 1 to 250
		#drawMessHere color(rnd(1)*256, rnd(1)*256, rnd(1)*256)
		#drawMessHere line(rnd(1)*1024, rnd(1)*768, rnd(1)*1024, rnd(1)*768)
	next x
	#drawMessHere "discard"
end sub

sub fonts #gr

end sub

[bitBlit]

	return

[sprites]

	return

[printing]

	return
